Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4495)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4497)
@@ -1,21 +1,21 @@
 !> @file wind_turbine_model_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANYr
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 2009-2020 Carl von Ossietzky Universitaet Oldenburg
 ! Copyright 1997-2020 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+!
 !
 ! Current revisions:
@@ -26,110 +26,108 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+!
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
 ! 4481 2020-03-31 18:55:54Z maronga
 ! ASCII output cleanup
-! 
+!
 ! 4465 2020-03-20 11:35:48Z maronga
-! Removed old ASCII outputm, some syntax layout adjustments, added output for
-! rotor and tower diameters. Added warning message in case of NetCDF 3 (no
-! WTM output file will be produced).
-! 
+! Removed old ASCII outputm, some syntax layout adjustments, added output for rotor and tower
+! diameters. Added warning message in case of NetCDF 3 (no WTM output file will be produced).
+!
 ! 4460 2020-03-12 16:47:30Z oliver.maas
 ! allow for simulating up to 10 000 wind turbines
-! 
+!
 ! 4459 2020-03-12 09:35:23Z oliver.maas
 ! avoid division by zero in tip loss correction factor calculation
-! 
+!
 ! 4457 2020-03-11 14:20:43Z raasch
 ! use statement for exchange horiz added
-! 
+!
 ! 4447 2020-03-06 11:05:30Z oliver.maas
 ! renamed wind_turbine_parameters namelist variables
-! 
+!
 ! 4438 2020-03-03 20:49:28Z suehring
 ! Bugfix: shifted netcdf preprocessor directive to correct position
-! 
+!
 ! 4436 2020-03-03 12:47:02Z oliver.maas
 ! added optional netcdf data input for wtm array input parameters
-! 
+!
 ! 4426 2020-02-27 10:02:19Z oliver.maas
-! define time as unlimited dimension so that no maximum number
-! of time steps has to be given for wtm_data_output
-! 
+! define time as unlimited dimension so that no maximum number of time steps has to be given for
+! wtm_data_output
+!
 ! 4423 2020-02-25 07:17:11Z maronga
 ! Switched to serial output as data is aggerated before anyway.
-! 
+!
 ! 4420 2020-02-24 14:13:56Z maronga
 ! Added output control for wind turbine model
-! 
+!
 ! 4412 2020-02-19 14:53:13Z maronga
 ! Bugfix: corrected character length in dimension_names
-! 
+!
 ! 4411 2020-02-18 14:28:02Z maronga
 ! Added output in NetCDF format using DOM (only netcdf4-parallel is supported).
 ! Old ASCII output is still available at the moment.
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-! 
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
+!
 ! 4343 2019-12-17 12:26:12Z oliver.maas
-! replaced <= by < in line 1464 to ensure that ialpha will not be 
-! greater than dlen
-! 
+! replaced <= by < in line 1464 to ensure that ialpha will not be greater than dlen
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4326 2019-12-06 14:16:14Z oliver.maas
-! changed format of turbine control output to allow for higher 
-! torque and power values
-! 
+! changed format of turbine control output to allow for higher torque and power values
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4144 2019-08-06 09:11:47Z raasch
 ! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
-! 
+!
 ! 4056 2019-06-27 13:53:16Z Giersch
-! CASE DEFAULT action in wtm_actions needs to be CONTINUE. Otherwise an abort  
-! will happen for location values that are not implemented as CASE statements
-! but are already realized in the code (e.g. pt-tendency) 
-! 
+! CASE DEFAULT action in wtm_actions needs to be CONTINUE. Otherwise an abort will happen for
+! location values that are not implemented as CASE statements but are already realized in the code
+! (e.g. pt-tendency)
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
 ! 3875 2019-04-08 17:35:12Z knoop
 ! Addaped wtm_tendency to fit the module actions interface
-! 
+!
 ! 3832 2019-03-28 13:16:58Z raasch
 ! instrumented with openmp directives
-! 
+!
 ! 3725 2019-02-07 10:11:02Z raasch
 ! unused variables removed
-! 
+!
 ! 3685 2019-01-21 01:02:11Z knoop
 ! Some interface calls moved to module_interface + cleanup
-! 
+!
 ! 3655 2019-01-07 16:51:22Z knoop
 ! Replace degree symbol by 'degrees'
-! 
+!
 ! 1914 2016-05-26 14:44:07Z witha
 ! Initial revision
-! 
+!
 !
 ! Description:
 ! ------------
-!> This module calculates the effect of wind turbines on the flow fields. The
-!> initial version contains only the advanced actuator disk with rotation method
-!> (ADM-R).
+!> This module calculates the effect of wind turbines on the flow fields. The initial version
+!> contains only the advanced actuator disk with rotation method (ADM-R).
 !> The wind turbines include the tower effect, can be yawed and tilted.
-!> The wind turbine model includes controllers for rotational speed, pitch and
-!> yaw.
-!> Currently some specifications of the NREL 5 MW reference turbine
-!> are hardcoded whereas most input data comes from separate files (currently
-!> external, planned to be included as namelist which will be read in
-!> automatically).
+!> The wind turbine model includes controllers for rotational speed, pitch and yaw.
+!> Currently some specifications of the NREL 5 MW reference turbine are hardcoded whereas most input
+!> data comes from separate files (currently external, planned to be included as namelist which will
+!> be read in automatically).
 !>
 !> @todo Replace dz(1) appropriatly to account for grid stretching
@@ -145,46 +143,47 @@
 !> @todo Allow different turbine types in one simulation
 !
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
  MODULE wind_turbine_model_mod
 
-    USE arrays_3d,                                                             &
+    USE arrays_3d,                                                                                 &
         ONLY:  tend, u, v, w, zu, zw
 
-    USE basic_constants_and_equations_mod,                                     &
+    USE basic_constants_and_equations_mod,                                                         &
         ONLY:  pi
 
-    USE control_parameters,                                                    &
-        ONLY:  coupling_char,                                                  &
-               debug_output,                                                   &
-               dt_3d, dz, end_time, message_string, restart_data_format_output, time_since_reference_point,&
-               wind_turbine, initializing_actions, origin_date_time
-
-    USE cpulog,                                                                &
+    USE control_parameters,                                                                        &
+        ONLY:  coupling_char,                                                                      &
+               debug_output,                                                                       &
+               dt_3d, dz, end_time, initializing_actions, message_string,                          &
+               origin_date_time, restart_data_format_output, time_since_reference_point,           &
+               wind_turbine
+
+    USE cpulog,                                                                                    &
         ONLY:  cpu_log, log_point_s
 
     USE data_output_module
-        
-    USE grid_variables,                                                        &
+
+    USE grid_variables,                                                                            &
         ONLY:  ddx, dx, ddy, dy
 
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,   &
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg, nz,                       &
                nzb, nzt, wall_flags_total_0
 
     USE kinds
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  check_existence,                                                &
-               close_input_file,                                               &
-               get_variable,                                                   &
-               input_pids_wtm,                                                 &
-               inquire_num_variables,                                          &
-               inquire_variable_names,                                         &
-               input_file_wtm,                                                 &
-               num_var_pids,                                                   &
-               open_read_file,                                                 &
-               pids_id,                                                        &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  check_existence,                                                                    &
+               close_input_file,                                                                   &
+               get_variable,                                                                       &
+               input_pids_wtm,                                                                     &
+               inquire_num_variables,                                                              &
+               inquire_variable_names,                                                             &
+               input_file_wtm,                                                                     &
+               num_var_pids,                                                                       &
+               open_read_file,                                                                     &
+               pids_id,                                                                            &
                vars_pids
-    
+
     USE pegrid
 
@@ -192,37 +191,40 @@
         ONLY:  rrd_mpi_io_global_array, wrd_mpi_io_global_array
 
-
+        
     IMPLICIT NONE
 
     PRIVATE
 
-    INTEGER(iwp), PARAMETER ::  n_turbines_max = 10000   !< maximum number of turbines (for array allocation)
-
     CHARACTER(LEN=100) ::  variable_name  !< name of output variable
-    CHARACTER(LEN=30) :: nc_filename 
-    
+    CHARACTER(LEN=30)  ::  nc_filename    !<
+
+
+    INTEGER(iwp), PARAMETER ::  n_turbines_max = 1000  !< maximum number of turbines (for array allocation)
+
+
 !
 !-- Variables specified in the namelist wind_turbine_par
-
-    INTEGER(iwp) ::  n_airfoils = 8   !< number of airfoils of the used turbine model (for ADM-R and ALM)
-    INTEGER(iwp) ::  n_turbines = 1   !< number of turbines
-    
-    
-    REAL(wp), DIMENSION(:), POINTER   ::  output_values_1d_pointer !< pointer for 2d output array
-    REAL(wp), POINTER                 ::  output_values_0d_pointer !< pointer for 2d output array  
-    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET   ::  output_values_1d_target !< pointer for 2d output array
-    REAL(wp), TARGET                ::  output_values_0d_target !< pointer for 2d output array     
-    
-    LOGICAL ::  pitch_control       = .FALSE.   !< switch for use of pitch controller
-    LOGICAL ::  speed_control       = .FALSE.   !< switch for use of speed controller
-    LOGICAL ::  yaw_control         = .FALSE.   !< switch for use of yaw controller
-    LOGICAL ::  tip_loss_correction = .FALSE.   !< switch for use of tip loss correct.
-    
-    LOGICAL ::  initial_write_coordinates = .FALSE. 
-    
-    REAL(wp) ::  dt_data_output_wtm = 0.0_wp       !< data output interval
-    REAL(wp) ::  time_wtm           = 0.0_wp       !< time since last data output
-    
-    
+    INTEGER(iwp) ::  n_airfoils = 8  !< number of airfoils of the used turbine model (for ADM-R and ALM)
+    INTEGER(iwp) ::  n_turbines = 1  !< number of turbines
+
+    LOGICAL ::  pitch_control       = .FALSE.  !< switch for use of pitch controller
+    LOGICAL ::  speed_control       = .FALSE.  !< switch for use of speed controller
+    LOGICAL ::  tip_loss_correction = .FALSE.  !< switch for use of tip loss correct.
+    LOGICAL ::  yaw_control         = .FALSE.  !< switch for use of yaw controller
+
+
+    LOGICAL ::  initial_write_coordinates = .FALSE.  !<
+
+
+    REAL(wp), DIMENSION(:), POINTER   ::  output_values_1d_pointer  !< pointer for 2d output array
+    REAL(wp), POINTER                 ::  output_values_0d_pointer  !< pointer for 2d output array
+    REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET ::  output_values_1d_target  !< pointer for 2d output array
+    REAL(wp), TARGET                  ::  output_values_0d_target   !< pointer for 2d output array
+
+
+    REAL(wp) ::  dt_data_output_wtm = 0.0_wp  !< data output interval
+    REAL(wp) ::  time_wtm           = 0.0_wp  !< time since last data output
+
+
     REAL(wp) ::  segment_length_tangential  = 1.0_wp  !< length of the segments, the rotor area is divided into
                                                       !< (in tangential direction, as factor of MIN(dx,dy,dz))
@@ -230,127 +232,122 @@
                                                       !< (in radial direction, as factor of MIN(dx,dy,dz))
     REAL(wp) ::  time_turbine_on            = 0.0_wp  !< time at which turbines are started
-    REAL(wp) ::  tilt_angle                       = 0.0_wp  !< vertical tilt_angle of the rotor [degree] ( positive = backwards )
-
-
-    REAL(wp), DIMENSION(1:n_turbines_max) ::  tower_diameter      = 0.0_wp       !< tower diameter [m]
-    REAL(wp), DIMENSION(1:n_turbines_max), TARGET ::  rotor_speed = 0.9_wp       !< inital or constant rotor speed [rad/s]
-    REAL(wp), DIMENSION(1:n_turbines_max) ::  yaw_angle           = 0.0_wp       !< yaw angle [degree] ( clockwise, 0 = facing west )
-    REAL(wp), DIMENSION(1:n_turbines_max) ::  pitch_angle         = 0.0_wp       !< constant pitch angle
+    REAL(wp) ::  tilt_angle                 = 0.0_wp  !< vertical tilt_angle of the rotor [degree] ( positive = backwards )
+
+                                                                                 !< ( clockwise, 0 = facing west )
     REAL(wp), DIMENSION(1:n_turbines_max) ::  hub_x               = 9999999.9_wp !< position of hub in x-direction
     REAL(wp), DIMENSION(1:n_turbines_max) ::  hub_y               = 9999999.9_wp !< position of hub in y-direction
     REAL(wp), DIMENSION(1:n_turbines_max) ::  hub_z               = 9999999.9_wp !< position of hub in z-direction
     REAL(wp), DIMENSION(1:n_turbines_max) ::  nacelle_radius      = 0.0_wp       !< nacelle diameter [m]
-    REAL(wp), DIMENSION(1:n_turbines_max) ::  rotor_radius        = 63.0_wp      !< rotor radius [m]
 !    REAL(wp), DIMENSION(1:n_turbines_max) ::  nacelle_cd          = 0.85_wp      !< drag coefficient for nacelle
     REAL(wp), DIMENSION(1:n_turbines_max) ::  tower_cd            = 1.2_wp       !< drag coefficient for tower
+    REAL(wp), DIMENSION(1:n_turbines_max) ::  pitch_angle         = 0.0_wp       !< constant pitch angle
+    REAL(wp), DIMENSION(1:n_turbines_max) ::  rotor_radius        = 63.0_wp      !< rotor radius [m]
+    REAL(wp), DIMENSION(1:n_turbines_max), TARGET ::  rotor_speed = 0.9_wp       !< inital or constant rotor speed [rad/s]
+    REAL(wp), DIMENSION(1:n_turbines_max) ::  tower_diameter      = 0.0_wp       !< tower diameter [m]
+    REAL(wp), DIMENSION(1:n_turbines_max) ::  yaw_angle           = 0.0_wp       !< yaw angle [degree]
+
 
 !
 !-- Variables specified in the namelist for speed controller
 !-- Default values are from the NREL 5MW research turbine (Jonkman, 2008)
-
-    REAL(wp) ::  generator_power_rated     = 5296610.0_wp    !< rated turbine power [W]
-    REAL(wp) ::  gear_ratio                = 97.0_wp         !< Gear ratio from rotor to generator
-    REAL(wp) ::  rotor_inertia             = 34784179.0_wp   !< Inertia of the rotor [kg*m2]
-    REAL(wp) ::  generator_inertia         = 534.116_wp      !< Inertia of the generator [kg*m2]
-    REAL(wp) ::  generator_efficiency      = 0.944_wp        !< Electric efficiency of the generator
-    REAL(wp) ::  gear_efficiency           = 1.0_wp          !< Loss between rotor and generator
-    REAL(wp) ::  air_density               = 1.225_wp        !< Air density to convert to W [kg/m3]
-    REAL(wp) ::  generator_speed_rated     = 121.6805_wp     !< Rated generator speed [rad/s]
-    REAL(wp) ::  generator_torque_max      = 47402.91_wp     !< Maximum of the generator torque [Nm]
-    REAL(wp) ::  region_2_slope            = 2.332287_wp     !< Slope constant for region 2
-    REAL(wp) ::  region_2_min              = 91.21091_wp     !< Lower generator speed boundary of region 2 [rad/s]
-    REAL(wp) ::  region_15_min             = 70.16224_wp     !< Lower generator speed boundary of region 1.5 [rad/s]
-    REAL(wp) ::  generator_torque_rate_max = 15000.0_wp      !< Max generator torque increase [Nm/s]
-    REAL(wp) ::  pitch_rate                = 8.0_wp          !< Max pitch rate [degree/s]
-
-
-!
-!-- Variables specified in the namelist for yaw control
-
-    REAL(wp) ::  yaw_speed            = 0.005236_wp    !< speed of the yaw actuator [rad/s]
-    REAL(wp) ::  yaw_misalignment_max = 0.08726_wp     !< maximum tolerated yaw missalignment [rad]
-    REAL(wp) ::  yaw_misalignment_min = 0.008726_wp    !< minimum yaw missalignment for which the actuator stops [rad]
-
-
-!
-!-- Variables for initialization of the turbine model
-
-    INTEGER(iwp) ::  inot         !< turbine loop index (turbine id)
-    INTEGER(iwp) ::  nsegs_max    !< maximum number of segments (all turbines, required for allocation of arrays)
-    INTEGER(iwp) ::  nrings_max   !< maximum number of rings (all turbines, required for allocation of arrays)
-    INTEGER(iwp) ::  ring         !< ring loop index (ring number)
-    INTEGER(iwp) ::  upper_end    !<
-
-    INTEGER(iwp), DIMENSION(1) ::  lct   !<
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i_hub     !< index belonging to x-position of the turbine
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i_smear   !< index defining the area for the smearing of the forces (x-direction)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j_hub     !< index belonging to y-position of the turbine
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j_smear   !< index defining the area for the smearing of the forces (y-direction)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_hub     !< index belonging to hub height
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_smear   !< index defining the area for the smearing of the forces (z-direction)
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nrings    !< number of rings per turbine
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nsegs_total !< total number of segments per turbine 
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nsegs   !< number of segments per ring and turbine
-
-!
-!-  parameters for the smearing from the rotor to the cartesian grid   
-    REAL(wp) ::  pol_a            !< parameter for the polynomial smearing fct
-    REAL(wp) ::  pol_b            !< parameter for the polynomial smearing fct
-    REAL(wp) ::  delta_t_factor   !< 
-    REAL(wp) ::  eps_factor       !<  
-    REAL(wp) ::  eps_min          !< 
-    REAL(wp) ::  eps_min2         !< 
-
-!
-!-- Variables for the calculation of lift and drag coefficients
-    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  ard     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  crd     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  delta_r !< radial segment length
-    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  lrd     !<
-    
-    REAL(wp) ::  accu_cl_cd_tab = 0.1_wp  !< Accuracy of the interpolation of 
-                                          !< the lift and drag coeff [deg] 
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: turb_cd_tab   !< table of the blade drag coefficient
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: turb_cl_tab   !< table of the blade lift coefficient
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  nac_cd_surf  !< 3d field of the tower drag coefficient 
+    REAL(wp) ::  air_density               = 1.225_wp       !< Air density to convert to W [kg/m3]
+    REAL(wp) ::  gear_efficiency           = 1.0_wp         !< Loss between rotor and generator
+    REAL(wp) ::  gear_ratio                = 97.0_wp        !< Gear ratio from rotor to generator
+    REAL(wp) ::  generator_power_rated     = 5296610.0_wp   !< rated turbine power [W]
+    REAL(wp) ::  generator_inertia         = 534.116_wp     !< Inertia of the generator [kg*m2]
+    REAL(wp) ::  generator_efficiency      = 0.944_wp       !< Electric efficiency of the generator
+    REAL(wp) ::  generator_speed_rated     = 121.6805_wp    !< Rated generator speed [rad/s]
+    REAL(wp) ::  generator_torque_max      = 47402.91_wp    !< Maximum of the generator torque [Nm]
+    REAL(wp) ::  generator_torque_rate_max = 15000.0_wp     !< Max generator torque increase [Nm/s]
+    REAL(wp) ::  pitch_rate                = 8.0_wp         !< Max pitch rate [degree/s]
+    REAL(wp) ::  region_2_slope            = 2.332287_wp    !< Slope constant for region 2
+    REAL(wp) ::  region_2_min              = 91.21091_wp    !< Lower generator speed boundary of region 2 [rad/s]
+    REAL(wp) ::  region_15_min             = 70.16224_wp    !< Lower generator speed boundary of region 1.5 [rad/s]
+    REAL(wp) ::  rotor_inertia             = 34784179.0_wp  !< Inertia of the rotor [kg*m2]
+
+
+
+!
+!-- Variables specified in the namelist for yaw control:
+    REAL(wp) ::  yaw_misalignment_max = 0.08726_wp   !< maximum tolerated yaw missalignment [rad]
+    REAL(wp) ::  yaw_misalignment_min = 0.008726_wp  !< minimum yaw missalignment for which the actuator stops [rad]
+    REAL(wp) ::  yaw_speed            = 0.005236_wp  !< speed of the yaw actuator [rad/s]
+
+!
+!-- Variables for initialization of the turbine model:
+    INTEGER(iwp) ::  inot        !< turbine loop index (turbine id)
+    INTEGER(iwp) ::  nsegs_max   !< maximum number of segments (all turbines, required for allocation of arrays)
+    INTEGER(iwp) ::  nrings_max  !< maximum number of rings (all turbines, required for allocation of arrays)
+    INTEGER(iwp) ::  ring        !< ring loop index (ring number)
+    INTEGER(iwp) ::  upper_end   !<
+
+    INTEGER(iwp), DIMENSION(1) ::  lct  !<
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i_hub    !< index belonging to x-position of the turbine
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  i_smear  !< index defining the area for the smearing of the forces (x-direction)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j_hub    !< index belonging to y-position of the turbine
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  j_smear  !< index defining the area for the smearing of the forces (y-direction)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_hub    !< index belonging to hub height
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  k_smear  !< index defining the area for the smearing of the forces (z-direction)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nrings   !< number of rings per turbine
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nsegs_total  !< total number of segments per turbine
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nsegs  !< number of segments per ring and turbine
+
+!
+!-  Parameters for the smearing from the rotor to the cartesian grid:
+    REAL(wp) ::  delta_t_factor  !<
+    REAL(wp) ::  eps_factor      !<
+    REAL(wp) ::  eps_min         !<
+    REAL(wp) ::  eps_min2        !<
+    REAL(wp) ::  pol_a           !< parameter for the polynomial smearing fct
+    REAL(wp) ::  pol_b           !< parameter for the polynomial smearing fct
+!
+!-- Variables for the calculation of lift and drag coefficients:
+    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  ard      !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  crd      !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  delta_r  !< radial segment length
+    REAL(wp), DIMENSION(:), ALLOCATABLE  ::  lrd      !<
+
+    REAL(wp) ::  accu_cl_cd_tab = 0.1_wp  !< Accuracy of the interpolation of the lift and drag coeff [deg]
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: turb_cd_tab  !< table of the blade drag coefficient
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: turb_cl_tab  !< table of the blade lift coefficient
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  nac_cd_surf  !< 3d field of the tower drag coefficient
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tow_cd_surf  !< 3d field of the nacelle drag coefficient
 
 !
-!-- Variables for the calculation of the forces
-     
-    REAL(wp) ::  cur_r                       !< 
-    REAL(wp) ::  phi_rotor                   !< 
-    REAL(wp) ::  pre_factor                  !<  
-    REAL(wp) ::  torque_seg                  !< 
-    REAL(wp) ::  u_int_l                     !< 
-    REAL(wp) ::  u_int_u                     !< 
-    REAL(wp) ::  u_rot                       !< 
-    REAL(wp) ::  v_int_l                     !< 
-    REAL(wp) ::  v_int_u                     !< 
-    REAL(wp) ::  w_int_l                     !< 
-    REAL(wp) ::  w_int_u                     !<
+!-- Variables for the calculation of the forces:
+    REAL(wp) ::  cur_r       !<
+    REAL(wp) ::  phi_rotor   !<
+    REAL(wp) ::  pre_factor  !<
+    REAL(wp) ::  torque_seg  !<
+    REAL(wp) ::  u_int_l     !<
+    REAL(wp) ::  u_int_u     !<
+    REAL(wp) ::  u_rot       !<
+    REAL(wp) ::  v_int_l     !<
+    REAL(wp) ::  v_int_u     !<
+    REAL(wp) ::  w_int_l     !<
+    REAL(wp) ::  w_int_u     !<
     !$OMP THREADPRIVATE (cur_r, phi_rotor, pre_factor, torque_seg, u_int_l, u_int_u, u_rot, &
     !$OMP&               v_int_l, v_int_u, w_int_l, w_int_u)
 !
-!-  Tendencies from the nacelle and tower thrust
-    REAL(wp) ::  tend_nac_x = 0.0_wp  !< 
-    REAL(wp) ::  tend_tow_x = 0.0_wp  !< 
-    REAL(wp) ::  tend_nac_y = 0.0_wp  !< 
+!-  Tendencies from the nacelle and tower thrust:
+    REAL(wp) ::  tend_nac_x = 0.0_wp  !<
+    REAL(wp) ::  tend_nac_y = 0.0_wp  !<
+    REAL(wp) ::  tend_tow_x = 0.0_wp  !<
     REAL(wp) ::  tend_tow_y = 0.0_wp  !<
     !$OMP THREADPRIVATE (tend_nac_x, tend_tow_x, tend_nac_y, tend_tow_y)
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  alpha_attack !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  chord        !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  phi_rel      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  torque_total !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  thrust_rotor !<
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  turb_cl      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  turb_cd      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vrel         !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vtheta       !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  alpha_attack  !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  chord         !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  phi_rel       !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  torque_total  !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  thrust_rotor  !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  turb_cd       !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  turb_cl       !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vrel          !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vtheta        !<
 
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rbx, rby, rbz     !< coordinates of the blade elements
